/*
 * AutomatonIteration.h
 *
 *  Created on: 29. 11. 2014
 *	  Author: Tomas Pecka
 */

#ifndef AUTOMATON_ITERATION_H_
#define AUTOMATON_ITERATION_H_

#include <core/multipleDispatch.hpp>
#include <automaton/Automaton.h>
#include <automaton/FSM/EpsilonNFA.h>

namespace automaton {

namespace transform {

/**
 * Iterates language given by automaton
 *  - For finite automaton A1, we create automaton L accepting L(A1)*
 */
class AutomatonIteration : public std::SingleDispatch<AutomatonIteration, automaton::Automaton, const automaton::AutomatonBase &> {
public:
	static automaton::Automaton iteration(const automaton::Automaton& automaton);

	static automaton::NFA < > iteration(const automaton::DFA < > & automaton);
	static automaton::NFA < > iteration(const automaton::NFA < > & automaton);
};

} /* namespace transform */

} /* namespace automaton */

#endif /* AUTOMATON_ITERATION_H_ */
